/*
 * PM - 2016
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <avr/eeprom.h>

/* vectori in care retin pinii fiecarei linii si coloane */
int pa[8] = {PA7, PA6, PA5, PA4, PA3, PA2, PA1, PA0};
int pc[8] = {PC7, PC6, PC5, PC4, PC3, PC2, PC1, PC0};
int pb[8] = {PB7, PB6, PB5, PB4, PB3, PB2, PB1, PB0};

int iter = 0;

/* piese initiale */

int p1r[4] = {-1, -1, -1, -2};
int p1c[4] = {2, 3, 4, 4};

int p2r[4] = {-4, -3, -2, -1};
int p2c[4] = {3, 3, 3, 3};

int p3r[4] = {-2, -2, -1, -1};
int p3c[4] = {3, 4, 3, 4};

int p4r[4] = {-2, -2, -1, -1};
int p4c[4] = {3, 4, 2, 3};

int p5r[4] = {-2, -1, -1, -1};
int p5c[4] = {3, 2, 3, 4};

/* matrice afisata la inceputul jocului */
int matrix[16][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{1, 0, 0, 0, 0, 0, 0, 1},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{1, 0, 0, 1, 1, 0, 0, 1},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* matrice afisata cand se pierde jocul */
int sad_face[16][8] = 
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{1, 0, 0, 0, 0, 0, 0, 1},
	{1, 0, 0, 1, 1, 0, 0, 1},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

int start_mat2[16][8] = 
{
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 0, 0, 0, 0, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1}
};

int start_mat3[16][8] = 
{
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 0, 0, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1}
};

int start_mat4[16][8] = 
{
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1},
	{1, 1, 1, 1, 1, 1, 1, 1}
};

/* matrice in care sunt retinute pozitiile pieselor pe parcursul jocului */
int game_matrix[16][8];

int prow[4];
int pcol[4];
int current = 0;
int position = 0;

/* functi pentru desenarea jocului pe matricile de leduri */
void draw_matrix(int matrix[16][8])
{
	int i, j;

	for (i = 0; i < 8; i++) {
		for (j = 0; j < 8; j++)
			if (matrix[j][i])
				PORTA |= (1 << pa[j]);
			else
				PORTA &= ~(1 << pa[j]);
				
		for (j = 0; j < 8; j++)
			if (matrix[j + 8][i])
				PORTB |= (1 << pb[j]);
			else
				PORTB &= ~(1 << pb[j]);

		PORTC |= (1 << pc[i]);
		_delay_ms(0.4);
		PORTC &= ~(1 << pc[i]);
	}
}

void draw_animation() {
	int i;
		
	for (i = 0; i < 50; i++)
		draw_matrix(start_mat2);
		
	for (i = 0; i < 50; i++)
		draw_matrix(start_mat3);
		
	for (i = 0; i < 50; i++)
		draw_matrix(start_mat4);
		
	for (i = 0; i < 50; i++)
		draw_matrix(start_mat3);
		
	for (i = 0; i < 50; i++)
		draw_matrix(start_mat2);
		
}

void init_rand()
{
        uint32_t state;
        static uint32_t EEMEM sstate;

        state = eeprom_read_dword(&sstate);

        if (state == 0xffffffUL)
                state = 0xDEADBEEFUL;
				
        srandom(state);
        eeprom_write_dword(&sstate, random());
}

/* functie care genereaza un sunet */
void make_sound(float frequency) {
	float perioada_nota = 100000 / frequency;
	int i, j;

	for (i = 0; i < 10; ++i) {
		PORTD |= (1 << PD6);

		for (j = 0; j < perioada_nota / 2; ++j)
			_delay_us(1);

		PORTD &= ~(1 << PD6);

		for (j = 0 ; j < perioada_nota / 2; ++j)
			_delay_us(1);
	}
}

/* functie care genereaza o piesa noua */
void new_piece() {

	int i;
	int rand_nr;
	
	init_rand();
	current = random() % 5;
	rand_nr = current;
	position = 0;
	
	switch(rand_nr) {
	case 0:
		for(i = 0; i < 4; i++) {
			prow[i] = p1r[i];
			pcol[i] = p1c[i];
		}
		break;
	case 1:
		for(i = 0; i < 4; i++) {
			prow[i] = p2r[i];
			pcol[i] = p2c[i];
		}
		break;
	case 2:
		for(i = 0; i < 4; i++) {
			prow[i] = p3r[i];
			pcol[i] = p3c[i];
		}
		break;
	case 3:
		for(i = 0; i < 4; i++) {
			prow[i] = p4r[i];
			pcol[i] = p4c[i];
		}
		break;
	case 4:
		for(i = 0; i < 4; i++) {
			prow[i] = p5r[i];
			pcol[i] = p5c[i];
		}
		break;
	default: break;
	}
	
	for (i = 0; i < 4; i++) {
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 1;
	}
}

/* functie care muta piesa curenta o pozitie in jos */
void move_down() {

	int i;
	
	for (i = 0; i < 4; i++) {
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 0;
		prow[i]++;
	}
	
	for (i = 0; i < 4; i++) 
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 1;

}

/* functie pentru mutarea piesei cu o pozitie la dreapta */
void move_right() {

	int i;
	
	for (i = 0; i < 4; i++)
		if (prow[i] < 0)
			return;
	
	int max_col = -1;
	
	/*determin coloana cu indicele cel mai mare*/
	for (i = 0; i < 4; i++)
		if (pcol[i] > max_col)
			max_col = pcol[i];
			
	/*verific daca mutarea e posibila*/
	if (max_col == 7)
		return;
		
	for (i = 0; i < 4; i++)
		if (pcol[i] == max_col && game_matrix[prow[i]][pcol[i] + 1] == 1)
			return;
			
	/*daca mutarea e valida sterg piesa si o reasez unde trebuie */
	/*cresc numarul coloanei*/
	for (i = 0; i < 4; i++) {
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 0;
		pcol[i]++;
	}
	
	for (i = 0; i < 4; i++) 
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 1;

}

/* functie pentru mutarea piesei cu o pozitie la stanga */
void move_left() {

	int i;
	
	for (i = 0; i < 4; i++)
		if (prow[i] < 0)
			return;
			
	int min_col = 16;
	
	/*determin coloana cu indicele cel mai mic*/
	for (i = 0; i < 4; i++)
		if (pcol[i] < min_col)
			min_col = pcol[i];
			
	/*verific daca mutarea e posibila*/
	if (min_col == 0)
		return;
		
	for (i = 0; i < 4; i++)
		if (pcol[i] == min_col && game_matrix[prow[i]][pcol[i] - 1] == 1)
			return;
			
	/*daca mutarea e valida sterg piesa si o reasez unde trebuie */
	/*cresc numarul coloanei*/
	for (i = 0; i < 4; i++) {
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 0;
		pcol[i]--;
	}
	
	for (i = 0; i < 4; i++) 
		if (prow[i] >= 0)
			game_matrix[prow[i]][pcol[i]] = 1;

}

/* functie care detecteaza coliziuni */
int detect_colision() {

	int i;
	int ret = 0;
	
	for (i = 0; i < 4; i++)
		game_matrix[prow[i]][pcol[i]] = 0;
	
	for (i = 0; i < 4; i++) {
		if (prow[i] == 15) {
			ret = 1;
			break;
		}
		else
			if (prow[i] + 1 > 0 && game_matrix[prow[i] + 1][pcol[i]] == 1) {
				ret = 1;
				break;
			}
	}
		
	for (i = 0; i < 4; i++)
		game_matrix[prow[i]][pcol[i]] = 1;
	
	return ret;
}

/* functie care detecteaza coliziunile in partea de sus a jocului
 * folosita pentru determinrea terminarii jocului */
int detect_colision_at_top() {

	int i;
	if(detect_colision() == 1) 
		for(i = 0; i < 4; i++)
			if(prow[i] < 0)
				return 1;
	return 0;
}

/* functie care sterge un rand daca acesta este plin */
void remove_row(int pos) {
	int i, j;
			
	/*mut piesele de deasupra randului cu un rand mai jos */
	for (i = pos; i > 0; i--)
		for (j = 0; j < 8; j++)
			game_matrix[i][j] = game_matrix[i - 1][j];
	
	for (j = 0; j < 8; j++)
		game_matrix[0][j] = 0;
}

/* functie care determina daca un rand e plin pentru a fi sters */
void detect_row() {

	int i, j, count;
	
	for (i = 0; i < 16; i++) {
		count = 0;
		for (j = 0; j < 8; j++)
			if (game_matrix[i][j] == 1)
				count++;
		if (count == 8) {
			make_sound(329.63);
			remove_row(i);
		}
	}
}

/* functie care determina daca o rotatie este posibila
 * (nu exista coliziuni, nu iese in afara matricei)
 */
int check_rotate(int row[4], int col[4]) {
	
	int i;
	
	for (i = 0; i < 4; i++) {
		if (row[i] < 0 || row[i] >= 16 || col[i] < 0 || col[i] >=8)
			return 0;
		if (game_matrix[row[i]][col[i]] == 1)
			return 0;
	}
	
	return 1;		
	
}
/* functie care roteste piesa curenta la dreapta */
void rotate() {

	int new_r[4];
	int new_c[4];
	int i;
	
	switch (current) {
	case 0:
		if (position == 0) {
			new_r[0] = prow[0] +1; new_r[1] = prow[1];
			new_r[2] = prow[2] - 1; new_r[3] = prow[3];
			new_c[0] = pcol[0] + 1; new_c[1] = pcol[1];
			new_c[2] = pcol[2] - 1; new_c[3] = pcol[3] - 2;
			break;
		}
		if (position == 1) {
			new_r[0] = prow[0] - 1; new_r[1] = prow[1];
			new_r[2] = prow[2] + 1; new_r[3] = prow[3] + 2;
			new_c[0] = pcol[0] + 1; new_c[1] = pcol[1];
			new_c[2] = pcol[2] - 1; new_c[3] = pcol[3];
			break;
		}
		if (position == 2) {
			new_r[0] = prow[0] - 1; new_r[1] = prow[1];
			new_r[2] = prow[2] + 1; new_r[3] = prow[3];
			new_c[0] = pcol[0] - 1; new_c[1] = pcol[1];
			new_c[2] = pcol[2] + 1; new_c[3] = pcol[3] + 2;
			break;
		}
		if (position == 3) {
			new_r[0] = prow[0] + 1; new_r[1] = prow[1];
			new_r[2] = prow[2] - 1; new_r[3] = prow[3] - 2;
			new_c[0] = pcol[0] - 1; new_c[1] = pcol[1];
			new_c[2] = pcol[2] + 1; new_c[3] = pcol[3];
			break;
		}
	case 1:
		if (position % 2 == 0) {
			new_r[0] = prow[0] + 2; new_r[1] = prow[1] + 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] - 1;
			new_c[0] = pcol[0] - 2; new_c[1] = pcol[1] - 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] + 1;
			break;
		}
		else {
			new_r[0] = prow[0] - 2; new_r[1] = prow[1] - 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] + 1;
			new_c[0] = pcol[0] + 2; new_c[1] = pcol[1] + 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] - 1;
			break;
		}
	case 2:
		new_r[0] = prow[0]; new_r[1] = prow[1];
		new_r[2] = prow[2]; new_r[3] = prow[3];
		new_c[0] = pcol[0]; new_c[1] = pcol[1];
		new_c[2] = pcol[2]; new_c[3] = pcol[3];
		break;
	case 3:
		if (position % 2 == 0) {
			new_r[0] = prow[0] + 1; new_r[1] = prow[1];
			new_r[2] = prow[2] + 1; new_r[3] = prow[3];
			new_c[0] = pcol[0] - 1; new_c[1] = pcol[1] - 2;
			new_c[2] = pcol[2] + 1; new_c[3] = pcol[3];
			break;
		}
		else {
			new_r[0] = prow[0] - 1; new_r[1] = prow[1];
			new_r[2] = prow[2] - 1; new_r[3] = prow[3];
			new_c[0] = pcol[0] + 1; new_c[1] = pcol[1] + 2;
			new_c[2] = pcol[2] - 1; new_c[3] = pcol[3];
			break;
		}
	case 4:
		if (position == 0) {
			new_r[0] = prow[0] + 1; new_r[1] = prow[1] + 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] - 1;
			new_c[0] = pcol[0] - 1; new_c[1] = pcol[1] + 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] - 1;
			break;
		}
		if (position == 1) {
			new_r[0] = prow[0] + 1; new_r[1] = prow[1] - 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] + 1;
			new_c[0] = pcol[0] + 1; new_c[1] = pcol[1] + 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] - 1;
			break;
		}
		if (position == 2) {
			new_r[0] = prow[0] - 1; new_r[1] = prow[1] - 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] + 1;
			new_c[0] = pcol[0] + 1; new_c[1] = pcol[1] - 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] + 1;
			break;
		}
		if (position == 3) {
			new_r[0] = prow[0] - 1; new_r[1] = prow[1] + 1;
			new_r[2] = prow[2]; new_r[3] = prow[3] - 1;
			new_c[0] = pcol[0] - 1; new_c[1] = pcol[1] - 1;
			new_c[2] = pcol[2]; new_c[3] = pcol[3] + 1;
			break;
		}
	}
	
	for (i = 0; i < 4; i++) 
		game_matrix[prow[i]][pcol[i]] = 0;
	if (check_rotate(new_r, new_c) == 1) {
		for (i = 0; i < 4; i++) {
			prow[i] = new_r[i];
			pcol[i] = new_c[i];
		}
		position = (position + 1) % 4;
	}
	for (i = 0; i < 4; i++) 
		game_matrix[prow[i]][pcol[i]] = 1;
}

/* functie care sterge matricea jocului pentru a incepe un joc nou */
void clear_matrix()
{
	int i, j;
	
	for (i = 0; i < 16; i++)
		for (j = 0; j < 8; j++)
			game_matrix[i][j] = 0;
}

void play(void) {
	
	start_game:
	while(1) {
		draw_matrix(matrix);
		iter++;
		
		if ((PIND & (1 << PD0)) == 0) {
			_delay_ms(100);
			iter = 0;
			goto new_game;
		}
	}
	
	start:
	while(1) {
		draw_matrix(sad_face);
		iter++;
		
		if ((PIND & (1 << PD0)) == 0) {
			iter = 0;
			break;
		}
	}
	
	new_game:
	clear_matrix();
	int colision = 1;
	int go_left = 0, go_right = 0, rot = 0, reset = 0;;
	draw_animation();
	
	while(1) {
		draw_matrix(game_matrix);
		iter++;
		
		if ((PIND & (1 << PD5)) == 0 && go_left == 0 && rot == 0)
			go_right = 1;

		if ((PIND & (1 << PD4)) == 0 && go_right == 0 && rot == 0) 
			go_left = 1;
			
		if ((PIND & (1 << PD1)) == 0 && go_left == 0 && go_right == 0)
			rot = 1;
			
		if ((PIND & (1 << PD0)) == 0) 
			reset = 1;
			
		if(iter == 200) {
			if (reset == 1) {
				colision = 1;
				goto start_game;
			}
			iter = 0;
			if (colision == 1) {
				new_piece();
				colision = 0;
			}
			else {
			
				
				if (detect_colision_at_top() == 1) {
					colision = 1;
					make_sound(261.63);
					goto start;
				}
				if (detect_colision() == 1) {
					colision = 1;
					detect_row();
					continue;
				}
				
				move_down();
				
				if (go_right == 1) {
					move_right();
					go_right = 0;
				}
				
				if (go_left == 1) {
					move_left();
					go_left = 0;
				}
				
				if (rot == 1) {
					rotate();
					rot = 0;
				}
					
			}
		}
	}
}

/* functie pentru initializare 
 * seteaza pinii de intrare sau de iesire 
 */
void init() {

	/* dezactivez jtag-ul */
	MCUCR |= (1 << JTD);
	MCUCR |= (1 << JTD);
	MCUCR |= (1 << JTD);
	MCUCR |= (1 << JTD);
	
	/* setez intrarile pentru butoane */
	DDRD &= ~(1 << PD0);
	DDRD &= ~(1 << PD1);
	DDRD &= ~(1 << PD4);
	DDRD &= ~(1 << PD5);

	/* activez rezistentele de pull-up */
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	
	/* setez porturile A, B si C ca iesiri */
	DDRA = 0xFF; 
	DDRC = 0xFF; 
	DDRB = 0xFF;
		
	/* sting ledurile */
	PORTA = 0x00;
	PORTC = 0x00;
	PORTB = 0x00;
	
	/* setez PD6 ca iesire pentru buzzer */
	DDRD |= (1 << PD6);
	PORTD &= ~(1 << PD6);
}


int main(void) {

	init();
	init_rand();
	play();
	
	return 0;
}
